# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Callable, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetApplicationGroupsGroupResult',
    'GetApplicationsApplicationResult',
    'GetExecutionsExecutionResult',
    'GetParametersParameterResult',
    'GetPatchBaselinesBaselineResult',
    'GetSecretParametersParameterResult',
    'GetStateConfigurationsConfigurationResult',
    'GetTemplatesTemplateResult',
]

@pulumi.output_type
class GetApplicationGroupsGroupResult(dict):
    def __init__(__self__, *,
                 application_group_name: str,
                 application_name: str,
                 cms_group_id: str,
                 create_time: str,
                 deploy_region_id: str,
                 description: str,
                 id: str,
                 import_tag_key: str,
                 import_tag_value: str,
                 update_time: str):
        """
        :param str application_group_name: The name of the Application group.
        :param str application_name: The name of the Application.
        :param str cms_group_id: The ID of the cloud monitor group.
        :param str create_time: The Creation time of the resource.
        :param str deploy_region_id: The region ID of the deployment.
        :param str description: Application group description information.
        :param str id: The ID of the Application Group. Its value is same as Queue Name.
        :param str import_tag_key: Label key.
        :param str import_tag_value: Label value.
        :param str update_time: The Update time of the resource.
        """
        GetApplicationGroupsGroupResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            application_group_name=application_group_name,
            application_name=application_name,
            cms_group_id=cms_group_id,
            create_time=create_time,
            deploy_region_id=deploy_region_id,
            description=description,
            id=id,
            import_tag_key=import_tag_key,
            import_tag_value=import_tag_value,
            update_time=update_time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             application_group_name: str,
             application_name: str,
             cms_group_id: str,
             create_time: str,
             deploy_region_id: str,
             description: str,
             id: str,
             import_tag_key: str,
             import_tag_value: str,
             update_time: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("application_group_name", application_group_name)
        _setter("application_name", application_name)
        _setter("cms_group_id", cms_group_id)
        _setter("create_time", create_time)
        _setter("deploy_region_id", deploy_region_id)
        _setter("description", description)
        _setter("id", id)
        _setter("import_tag_key", import_tag_key)
        _setter("import_tag_value", import_tag_value)
        _setter("update_time", update_time)

    @property
    @pulumi.getter(name="applicationGroupName")
    def application_group_name(self) -> str:
        """
        The name of the Application group.
        """
        return pulumi.get(self, "application_group_name")

    @property
    @pulumi.getter(name="applicationName")
    def application_name(self) -> str:
        """
        The name of the Application.
        """
        return pulumi.get(self, "application_name")

    @property
    @pulumi.getter(name="cmsGroupId")
    def cms_group_id(self) -> str:
        """
        The ID of the cloud monitor group.
        """
        return pulumi.get(self, "cms_group_id")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The Creation time of the resource.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="deployRegionId")
    def deploy_region_id(self) -> str:
        """
        The region ID of the deployment.
        """
        return pulumi.get(self, "deploy_region_id")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Application group description information.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Application Group. Its value is same as Queue Name.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="importTagKey")
    def import_tag_key(self) -> str:
        """
        Label key.
        """
        return pulumi.get(self, "import_tag_key")

    @property
    @pulumi.getter(name="importTagValue")
    def import_tag_value(self) -> str:
        """
        Label value.
        """
        return pulumi.get(self, "import_tag_value")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The Update time of the resource.
        """
        return pulumi.get(self, "update_time")


@pulumi.output_type
class GetApplicationsApplicationResult(dict):
    def __init__(__self__, *,
                 application_name: str,
                 create_time: str,
                 description: str,
                 id: str,
                 resource_group_id: str,
                 tags: Mapping[str, Any],
                 update_time: str):
        """
        :param str application_name: The name of the application.
        :param str create_time: The Created time of the application.
        :param str description: Application group description information.
        :param str id: The ID of the Application. The value is formate as <application_name>.
        :param str resource_group_id: The ID of the resource group.
        :param Mapping[str, Any] tags: The tag of the resource.
        :param str update_time: The Updated time of the application.
        """
        GetApplicationsApplicationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            application_name=application_name,
            create_time=create_time,
            description=description,
            id=id,
            resource_group_id=resource_group_id,
            tags=tags,
            update_time=update_time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             application_name: str,
             create_time: str,
             description: str,
             id: str,
             resource_group_id: str,
             tags: Mapping[str, Any],
             update_time: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("application_name", application_name)
        _setter("create_time", create_time)
        _setter("description", description)
        _setter("id", id)
        _setter("resource_group_id", resource_group_id)
        _setter("tags", tags)
        _setter("update_time", update_time)

    @property
    @pulumi.getter(name="applicationName")
    def application_name(self) -> str:
        """
        The name of the application.
        """
        return pulumi.get(self, "application_name")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The Created time of the application.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Application group description information.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Application. The value is formate as <application_name>.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resourceGroupId")
    def resource_group_id(self) -> str:
        """
        The ID of the resource group.
        """
        return pulumi.get(self, "resource_group_id")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        The tag of the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The Updated time of the application.
        """
        return pulumi.get(self, "update_time")


@pulumi.output_type
class GetExecutionsExecutionResult(dict):
    def __init__(__self__, *,
                 category: str,
                 counters: str,
                 create_date: str,
                 end_date: str,
                 executed_by: str,
                 execution_id: str,
                 id: str,
                 is_parent: bool,
                 mode: str,
                 outputs: str,
                 parameters: str,
                 parent_execution_id: str,
                 ram_role: str,
                 start_date: str,
                 status: str,
                 status_message: str,
                 status_reason: str,
                 template_id: str,
                 template_name: str,
                 template_version: str,
                 update_date: str):
        """
        :param str category: The category of template. Valid: `AlarmTrigger`, `EventTrigger`, `Other` and `TimerTrigger`.
        :param str counters: The counters of OOS Execution.
        :param str create_date: The time when the execution was created.
        :param str end_date: The time when the execution was ended.
        :param str executed_by: The user who execute the template.
        :param str execution_id: ID of the OOS Executions.
        :param str id: ID of the OOS Executions.
        :param bool is_parent: Whether to include subtasks.
        :param str mode: The mode of OOS Execution. Valid: `Automatic`, `Debug`.
        :param str outputs: The outputs of OOS Executions.
        :param str parameters: The parameters required by the template
        :param str parent_execution_id: The id of parent OOS Execution.
        :param str ram_role: The role that executes the current template.
        :param str start_date: The time when the template was started.
        :param str status: The Status of OOS Execution. Valid: `Cancelled`, `Failed`, `Queued`, `Running`, `Started`, `Success`, `Waiting`.
        :param str status_message: The message of status.
        :param str status_reason: The reason of status.
        :param str template_id: The id of execution template.
        :param str template_name: The name of execution template.
        :param str template_version: The version of execution template.
        :param str update_date: The time when the template was updated.
        """
        GetExecutionsExecutionResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            category=category,
            counters=counters,
            create_date=create_date,
            end_date=end_date,
            executed_by=executed_by,
            execution_id=execution_id,
            id=id,
            is_parent=is_parent,
            mode=mode,
            outputs=outputs,
            parameters=parameters,
            parent_execution_id=parent_execution_id,
            ram_role=ram_role,
            start_date=start_date,
            status=status,
            status_message=status_message,
            status_reason=status_reason,
            template_id=template_id,
            template_name=template_name,
            template_version=template_version,
            update_date=update_date,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             category: str,
             counters: str,
             create_date: str,
             end_date: str,
             executed_by: str,
             execution_id: str,
             id: str,
             is_parent: bool,
             mode: str,
             outputs: str,
             parameters: str,
             parent_execution_id: str,
             ram_role: str,
             start_date: str,
             status: str,
             status_message: str,
             status_reason: str,
             template_id: str,
             template_name: str,
             template_version: str,
             update_date: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("category", category)
        _setter("counters", counters)
        _setter("create_date", create_date)
        _setter("end_date", end_date)
        _setter("executed_by", executed_by)
        _setter("execution_id", execution_id)
        _setter("id", id)
        _setter("is_parent", is_parent)
        _setter("mode", mode)
        _setter("outputs", outputs)
        _setter("parameters", parameters)
        _setter("parent_execution_id", parent_execution_id)
        _setter("ram_role", ram_role)
        _setter("start_date", start_date)
        _setter("status", status)
        _setter("status_message", status_message)
        _setter("status_reason", status_reason)
        _setter("template_id", template_id)
        _setter("template_name", template_name)
        _setter("template_version", template_version)
        _setter("update_date", update_date)

    @property
    @pulumi.getter
    def category(self) -> str:
        """
        The category of template. Valid: `AlarmTrigger`, `EventTrigger`, `Other` and `TimerTrigger`.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter
    def counters(self) -> str:
        """
        The counters of OOS Execution.
        """
        return pulumi.get(self, "counters")

    @property
    @pulumi.getter(name="createDate")
    def create_date(self) -> str:
        """
        The time when the execution was created.
        """
        return pulumi.get(self, "create_date")

    @property
    @pulumi.getter(name="endDate")
    def end_date(self) -> str:
        """
        The time when the execution was ended.
        """
        return pulumi.get(self, "end_date")

    @property
    @pulumi.getter(name="executedBy")
    def executed_by(self) -> str:
        """
        The user who execute the template.
        """
        return pulumi.get(self, "executed_by")

    @property
    @pulumi.getter(name="executionId")
    def execution_id(self) -> str:
        """
        ID of the OOS Executions.
        """
        return pulumi.get(self, "execution_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        ID of the OOS Executions.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isParent")
    def is_parent(self) -> bool:
        """
        Whether to include subtasks.
        """
        return pulumi.get(self, "is_parent")

    @property
    @pulumi.getter
    def mode(self) -> str:
        """
        The mode of OOS Execution. Valid: `Automatic`, `Debug`.
        """
        return pulumi.get(self, "mode")

    @property
    @pulumi.getter
    def outputs(self) -> str:
        """
        The outputs of OOS Executions.
        """
        return pulumi.get(self, "outputs")

    @property
    @pulumi.getter
    def parameters(self) -> str:
        """
        The parameters required by the template
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="parentExecutionId")
    def parent_execution_id(self) -> str:
        """
        The id of parent OOS Execution.
        """
        return pulumi.get(self, "parent_execution_id")

    @property
    @pulumi.getter(name="ramRole")
    def ram_role(self) -> str:
        """
        The role that executes the current template.
        """
        return pulumi.get(self, "ram_role")

    @property
    @pulumi.getter(name="startDate")
    def start_date(self) -> str:
        """
        The time when the template was started.
        """
        return pulumi.get(self, "start_date")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        The Status of OOS Execution. Valid: `Cancelled`, `Failed`, `Queued`, `Running`, `Started`, `Success`, `Waiting`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="statusMessage")
    def status_message(self) -> str:
        """
        The message of status.
        """
        return pulumi.get(self, "status_message")

    @property
    @pulumi.getter(name="statusReason")
    def status_reason(self) -> str:
        """
        The reason of status.
        """
        return pulumi.get(self, "status_reason")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> str:
        """
        The id of execution template.
        """
        return pulumi.get(self, "template_id")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> str:
        """
        The name of execution template.
        """
        return pulumi.get(self, "template_name")

    @property
    @pulumi.getter(name="templateVersion")
    def template_version(self) -> str:
        """
        The version of execution template.
        """
        return pulumi.get(self, "template_version")

    @property
    @pulumi.getter(name="updateDate")
    def update_date(self) -> str:
        """
        The time when the template was updated.
        """
        return pulumi.get(self, "update_date")


@pulumi.output_type
class GetParametersParameterResult(dict):
    def __init__(__self__, *,
                 constraints: str,
                 create_time: str,
                 created_by: str,
                 description: str,
                 id: str,
                 parameter_id: str,
                 parameter_name: str,
                 parameter_version: int,
                 resource_group_id: str,
                 share_type: str,
                 tags: Mapping[str, Any],
                 type: str,
                 updated_by: str,
                 updated_date: str,
                 value: str):
        """
        :param str constraints: The constraints of the common parameter.
        :param str create_time: The time when the common parameter was created.
        :param str created_by: The user who created the common parameter.
        :param str description: The description of the common parameter.
        :param str id: The ID of the Parameter. Its value is same as `parameter_name`.
        :param str parameter_id: The ID of the common parameter.
        :param str parameter_name: The name of the common parameter.
        :param int parameter_version: The version number of the common parameter.
        :param str resource_group_id: The ID of the Resource Group.
        :param str share_type: The share type of the common parameter.
        :param Mapping[str, Any] tags: The tag of the resource.
        :param str type: The data type of the common parameter.
        :param str updated_by: The user who updated the common parameter.
        :param str updated_date: The time when the common parameter was updated.
        :param str value: The value of the common parameter.
        """
        GetParametersParameterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            constraints=constraints,
            create_time=create_time,
            created_by=created_by,
            description=description,
            id=id,
            parameter_id=parameter_id,
            parameter_name=parameter_name,
            parameter_version=parameter_version,
            resource_group_id=resource_group_id,
            share_type=share_type,
            tags=tags,
            type=type,
            updated_by=updated_by,
            updated_date=updated_date,
            value=value,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             constraints: str,
             create_time: str,
             created_by: str,
             description: str,
             id: str,
             parameter_id: str,
             parameter_name: str,
             parameter_version: int,
             resource_group_id: str,
             share_type: str,
             tags: Mapping[str, Any],
             type: str,
             updated_by: str,
             updated_date: str,
             value: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("constraints", constraints)
        _setter("create_time", create_time)
        _setter("created_by", created_by)
        _setter("description", description)
        _setter("id", id)
        _setter("parameter_id", parameter_id)
        _setter("parameter_name", parameter_name)
        _setter("parameter_version", parameter_version)
        _setter("resource_group_id", resource_group_id)
        _setter("share_type", share_type)
        _setter("tags", tags)
        _setter("type", type)
        _setter("updated_by", updated_by)
        _setter("updated_date", updated_date)
        _setter("value", value)

    @property
    @pulumi.getter
    def constraints(self) -> str:
        """
        The constraints of the common parameter.
        """
        return pulumi.get(self, "constraints")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The time when the common parameter was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        The user who created the common parameter.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the common parameter.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Parameter. Its value is same as `parameter_name`.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="parameterId")
    def parameter_id(self) -> str:
        """
        The ID of the common parameter.
        """
        return pulumi.get(self, "parameter_id")

    @property
    @pulumi.getter(name="parameterName")
    def parameter_name(self) -> str:
        """
        The name of the common parameter.
        """
        return pulumi.get(self, "parameter_name")

    @property
    @pulumi.getter(name="parameterVersion")
    def parameter_version(self) -> int:
        """
        The version number of the common parameter.
        """
        return pulumi.get(self, "parameter_version")

    @property
    @pulumi.getter(name="resourceGroupId")
    def resource_group_id(self) -> str:
        """
        The ID of the Resource Group.
        """
        return pulumi.get(self, "resource_group_id")

    @property
    @pulumi.getter(name="shareType")
    def share_type(self) -> str:
        """
        The share type of the common parameter.
        """
        return pulumi.get(self, "share_type")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        The tag of the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The data type of the common parameter.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedBy")
    def updated_by(self) -> str:
        """
        The user who updated the common parameter.
        """
        return pulumi.get(self, "updated_by")

    @property
    @pulumi.getter(name="updatedDate")
    def updated_date(self) -> str:
        """
        The time when the common parameter was updated.
        """
        return pulumi.get(self, "updated_date")

    @property
    @pulumi.getter
    def value(self) -> str:
        """
        The value of the common parameter.
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class GetPatchBaselinesBaselineResult(dict):
    def __init__(__self__, *,
                 approval_rules: str,
                 create_time: str,
                 created_by: str,
                 description: str,
                 id: str,
                 is_default: bool,
                 operation_system: str,
                 patch_baseline_id: str,
                 patch_baseline_name: str,
                 share_type: str,
                 updated_by: str,
                 updated_date: str):
        """
        :param str approval_rules: Accept the rules.
        :param str create_time: The create time of patch baselines.
        :param str created_by: The user who created the patch baselines.
        :param str description: Patches baseline description information.
        :param str id: The ID of the Patch Baseline. Its value is same as `patch_baseline_name`.
        :param bool is_default: Whether it is the default patch baseline.
        :param str operation_system: Operating system type.
        :param str patch_baseline_id: Patch baseline ID.
        :param str patch_baseline_name: The name of the patch baseline.
        :param str share_type: Patch baseline sharing type.
        :param str updated_by: The user who updated the patch baselines.
        :param str updated_date: The update time of patch baselines.
        """
        GetPatchBaselinesBaselineResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            approval_rules=approval_rules,
            create_time=create_time,
            created_by=created_by,
            description=description,
            id=id,
            is_default=is_default,
            operation_system=operation_system,
            patch_baseline_id=patch_baseline_id,
            patch_baseline_name=patch_baseline_name,
            share_type=share_type,
            updated_by=updated_by,
            updated_date=updated_date,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             approval_rules: str,
             create_time: str,
             created_by: str,
             description: str,
             id: str,
             is_default: bool,
             operation_system: str,
             patch_baseline_id: str,
             patch_baseline_name: str,
             share_type: str,
             updated_by: str,
             updated_date: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("approval_rules", approval_rules)
        _setter("create_time", create_time)
        _setter("created_by", created_by)
        _setter("description", description)
        _setter("id", id)
        _setter("is_default", is_default)
        _setter("operation_system", operation_system)
        _setter("patch_baseline_id", patch_baseline_id)
        _setter("patch_baseline_name", patch_baseline_name)
        _setter("share_type", share_type)
        _setter("updated_by", updated_by)
        _setter("updated_date", updated_date)

    @property
    @pulumi.getter(name="approvalRules")
    def approval_rules(self) -> str:
        """
        Accept the rules.
        """
        return pulumi.get(self, "approval_rules")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The create time of patch baselines.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        The user who created the patch baselines.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Patches baseline description information.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Patch Baseline. Its value is same as `patch_baseline_name`.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="isDefault")
    def is_default(self) -> bool:
        """
        Whether it is the default patch baseline.
        """
        return pulumi.get(self, "is_default")

    @property
    @pulumi.getter(name="operationSystem")
    def operation_system(self) -> str:
        """
        Operating system type.
        """
        return pulumi.get(self, "operation_system")

    @property
    @pulumi.getter(name="patchBaselineId")
    def patch_baseline_id(self) -> str:
        """
        Patch baseline ID.
        """
        return pulumi.get(self, "patch_baseline_id")

    @property
    @pulumi.getter(name="patchBaselineName")
    def patch_baseline_name(self) -> str:
        """
        The name of the patch baseline.
        """
        return pulumi.get(self, "patch_baseline_name")

    @property
    @pulumi.getter(name="shareType")
    def share_type(self) -> str:
        """
        Patch baseline sharing type.
        """
        return pulumi.get(self, "share_type")

    @property
    @pulumi.getter(name="updatedBy")
    def updated_by(self) -> str:
        """
        The user who updated the patch baselines.
        """
        return pulumi.get(self, "updated_by")

    @property
    @pulumi.getter(name="updatedDate")
    def updated_date(self) -> str:
        """
        The update time of patch baselines.
        """
        return pulumi.get(self, "updated_date")


@pulumi.output_type
class GetSecretParametersParameterResult(dict):
    def __init__(__self__, *,
                 constraints: str,
                 create_time: str,
                 created_by: str,
                 description: str,
                 id: str,
                 key_id: str,
                 parameter_version: int,
                 resource_group_id: str,
                 secret_parameter_id: str,
                 secret_parameter_name: str,
                 share_type: str,
                 tags: Mapping[str, Any],
                 type: str,
                 updated_by: str,
                 updated_date: str):
        """
        :param str constraints: The constraints of the encryption parameter.
        :param str create_time: The time when the encryption parameter was created.
        :param str created_by: The user who created the encryption parameter.
        :param str description: The description of the encryption parameter.
        :param str id: The ID of the Secret Parameter.
        :param str key_id: KeyId of KMS used for encryption.
        :param int parameter_version: The version number of the encryption parameter.
        :param str resource_group_id: The ID of the Resource Group.
        :param str secret_parameter_id: The ID of the encryption parameter.
        :param str secret_parameter_name: The name of the encryption parameter.
        :param str share_type: The share type of the encryption parameter.
        :param Mapping[str, Any] tags: The tag of the resource.
        :param str type: The data type of the encryption parameter.
        :param str updated_by: The user who updated the encryption parameter.
        :param str updated_date: The time when the encryption parameter was updated.
        """
        GetSecretParametersParameterResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            constraints=constraints,
            create_time=create_time,
            created_by=created_by,
            description=description,
            id=id,
            key_id=key_id,
            parameter_version=parameter_version,
            resource_group_id=resource_group_id,
            secret_parameter_id=secret_parameter_id,
            secret_parameter_name=secret_parameter_name,
            share_type=share_type,
            tags=tags,
            type=type,
            updated_by=updated_by,
            updated_date=updated_date,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             constraints: str,
             create_time: str,
             created_by: str,
             description: str,
             id: str,
             key_id: str,
             parameter_version: int,
             resource_group_id: str,
             secret_parameter_id: str,
             secret_parameter_name: str,
             share_type: str,
             tags: Mapping[str, Any],
             type: str,
             updated_by: str,
             updated_date: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("constraints", constraints)
        _setter("create_time", create_time)
        _setter("created_by", created_by)
        _setter("description", description)
        _setter("id", id)
        _setter("key_id", key_id)
        _setter("parameter_version", parameter_version)
        _setter("resource_group_id", resource_group_id)
        _setter("secret_parameter_id", secret_parameter_id)
        _setter("secret_parameter_name", secret_parameter_name)
        _setter("share_type", share_type)
        _setter("tags", tags)
        _setter("type", type)
        _setter("updated_by", updated_by)
        _setter("updated_date", updated_date)

    @property
    @pulumi.getter
    def constraints(self) -> str:
        """
        The constraints of the encryption parameter.
        """
        return pulumi.get(self, "constraints")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The time when the encryption parameter was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        The user who created the encryption parameter.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description of the encryption parameter.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the Secret Parameter.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyId")
    def key_id(self) -> str:
        """
        KeyId of KMS used for encryption.
        """
        return pulumi.get(self, "key_id")

    @property
    @pulumi.getter(name="parameterVersion")
    def parameter_version(self) -> int:
        """
        The version number of the encryption parameter.
        """
        return pulumi.get(self, "parameter_version")

    @property
    @pulumi.getter(name="resourceGroupId")
    def resource_group_id(self) -> str:
        """
        The ID of the Resource Group.
        """
        return pulumi.get(self, "resource_group_id")

    @property
    @pulumi.getter(name="secretParameterId")
    def secret_parameter_id(self) -> str:
        """
        The ID of the encryption parameter.
        """
        return pulumi.get(self, "secret_parameter_id")

    @property
    @pulumi.getter(name="secretParameterName")
    def secret_parameter_name(self) -> str:
        """
        The name of the encryption parameter.
        """
        return pulumi.get(self, "secret_parameter_name")

    @property
    @pulumi.getter(name="shareType")
    def share_type(self) -> str:
        """
        The share type of the encryption parameter.
        """
        return pulumi.get(self, "share_type")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        The tag of the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def type(self) -> str:
        """
        The data type of the encryption parameter.
        """
        return pulumi.get(self, "type")

    @property
    @pulumi.getter(name="updatedBy")
    def updated_by(self) -> str:
        """
        The user who updated the encryption parameter.
        """
        return pulumi.get(self, "updated_by")

    @property
    @pulumi.getter(name="updatedDate")
    def updated_date(self) -> str:
        """
        The time when the encryption parameter was updated.
        """
        return pulumi.get(self, "updated_date")


@pulumi.output_type
class GetStateConfigurationsConfigurationResult(dict):
    def __init__(__self__, *,
                 configure_mode: str,
                 create_time: str,
                 description: str,
                 id: str,
                 parameters: str,
                 resource_group_id: str,
                 schedule_expression: str,
                 schedule_type: str,
                 state_configuration_id: str,
                 tags: Mapping[str, Any],
                 targets: str,
                 template_id: str,
                 template_name: str,
                 template_version: str,
                 update_time: str):
        """
        :param str configure_mode: The configuration mode.
        :param str create_time: The creation time.
        :param str description: The description.
        :param str id: The ID of the State Configuration.
        :param str parameters: The parameters.
        :param str resource_group_id: The ID of the resource group.
        :param str schedule_expression: The schedule expression.
        :param str schedule_type: The schedule type.
        :param str state_configuration_id: The ID of the final state configuration.
        :param Mapping[str, Any] tags: The tag of the resource.
        :param str targets: The target resource.
        :param str template_id: The ID of the template.
        :param str template_name: The name of the template.
        :param str template_version: The version of the template.
        :param str update_time: The time when the configuration is updated.
        """
        GetStateConfigurationsConfigurationResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            configure_mode=configure_mode,
            create_time=create_time,
            description=description,
            id=id,
            parameters=parameters,
            resource_group_id=resource_group_id,
            schedule_expression=schedule_expression,
            schedule_type=schedule_type,
            state_configuration_id=state_configuration_id,
            tags=tags,
            targets=targets,
            template_id=template_id,
            template_name=template_name,
            template_version=template_version,
            update_time=update_time,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             configure_mode: str,
             create_time: str,
             description: str,
             id: str,
             parameters: str,
             resource_group_id: str,
             schedule_expression: str,
             schedule_type: str,
             state_configuration_id: str,
             tags: Mapping[str, Any],
             targets: str,
             template_id: str,
             template_name: str,
             template_version: str,
             update_time: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("configure_mode", configure_mode)
        _setter("create_time", create_time)
        _setter("description", description)
        _setter("id", id)
        _setter("parameters", parameters)
        _setter("resource_group_id", resource_group_id)
        _setter("schedule_expression", schedule_expression)
        _setter("schedule_type", schedule_type)
        _setter("state_configuration_id", state_configuration_id)
        _setter("tags", tags)
        _setter("targets", targets)
        _setter("template_id", template_id)
        _setter("template_name", template_name)
        _setter("template_version", template_version)
        _setter("update_time", update_time)

    @property
    @pulumi.getter(name="configureMode")
    def configure_mode(self) -> str:
        """
        The configuration mode.
        """
        return pulumi.get(self, "configure_mode")

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The creation time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        The description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of the State Configuration.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def parameters(self) -> str:
        """
        The parameters.
        """
        return pulumi.get(self, "parameters")

    @property
    @pulumi.getter(name="resourceGroupId")
    def resource_group_id(self) -> str:
        """
        The ID of the resource group.
        """
        return pulumi.get(self, "resource_group_id")

    @property
    @pulumi.getter(name="scheduleExpression")
    def schedule_expression(self) -> str:
        """
        The schedule expression.
        """
        return pulumi.get(self, "schedule_expression")

    @property
    @pulumi.getter(name="scheduleType")
    def schedule_type(self) -> str:
        """
        The schedule type.
        """
        return pulumi.get(self, "schedule_type")

    @property
    @pulumi.getter(name="stateConfigurationId")
    def state_configuration_id(self) -> str:
        """
        The ID of the final state configuration.
        """
        return pulumi.get(self, "state_configuration_id")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        The tag of the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def targets(self) -> str:
        """
        The target resource.
        """
        return pulumi.get(self, "targets")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> str:
        """
        The ID of the template.
        """
        return pulumi.get(self, "template_id")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> str:
        """
        The name of the template.
        """
        return pulumi.get(self, "template_name")

    @property
    @pulumi.getter(name="templateVersion")
    def template_version(self) -> str:
        """
        The version of the template.
        """
        return pulumi.get(self, "template_version")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The time when the configuration is updated.
        """
        return pulumi.get(self, "update_time")


@pulumi.output_type
class GetTemplatesTemplateResult(dict):
    def __init__(__self__, *,
                 category: str,
                 created_by: str,
                 created_date: str,
                 description: str,
                 has_trigger: bool,
                 id: str,
                 share_type: str,
                 tags: Mapping[str, Any],
                 template_format: str,
                 template_id: str,
                 template_name: str,
                 template_type: str,
                 template_version: str,
                 updated_by: str,
                 updated_date: str):
        """
        :param str category: The category of template.
        :param str created_by: The creator of the template.
        :param str created_date: The template whose creation time is less than or equal to the specified time. The format is: YYYY-MM-DDThh:mm::ssZ.
        :param str description: Description of the OOS Template.
        :param bool has_trigger: Is it triggered successfully.
        :param str id: ID of the OOS Template. The value is same as template_name.
        :param str share_type: The sharing type of the template. Valid values: `Private`, `Public`.
        :param Mapping[str, Any] tags: A mapping of tags to assign to the resource.
        :param str template_format: The format of the template. Valid values: `JSON`, `YAML`.
        :param str template_id: ID of the OOS Template resource.
        :param str template_name: Name of the OOS Template.
        :param str template_type: The type of OOS Template.
        :param str template_version: Version of the OOS Template.
        :param str updated_by: The user who updated the template.
        :param str updated_date: The time when the template was updated.
        """
        GetTemplatesTemplateResult._configure(
            lambda key, value: pulumi.set(__self__, key, value),
            category=category,
            created_by=created_by,
            created_date=created_date,
            description=description,
            has_trigger=has_trigger,
            id=id,
            share_type=share_type,
            tags=tags,
            template_format=template_format,
            template_id=template_id,
            template_name=template_name,
            template_type=template_type,
            template_version=template_version,
            updated_by=updated_by,
            updated_date=updated_date,
        )
    @staticmethod
    def _configure(
             _setter: Callable[[Any, Any], None],
             category: str,
             created_by: str,
             created_date: str,
             description: str,
             has_trigger: bool,
             id: str,
             share_type: str,
             tags: Mapping[str, Any],
             template_format: str,
             template_id: str,
             template_name: str,
             template_type: str,
             template_version: str,
             updated_by: str,
             updated_date: str,
             opts: Optional[pulumi.ResourceOptions]=None):
        _setter("category", category)
        _setter("created_by", created_by)
        _setter("created_date", created_date)
        _setter("description", description)
        _setter("has_trigger", has_trigger)
        _setter("id", id)
        _setter("share_type", share_type)
        _setter("tags", tags)
        _setter("template_format", template_format)
        _setter("template_id", template_id)
        _setter("template_name", template_name)
        _setter("template_type", template_type)
        _setter("template_version", template_version)
        _setter("updated_by", updated_by)
        _setter("updated_date", updated_date)

    @property
    @pulumi.getter
    def category(self) -> str:
        """
        The category of template.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter(name="createdBy")
    def created_by(self) -> str:
        """
        The creator of the template.
        """
        return pulumi.get(self, "created_by")

    @property
    @pulumi.getter(name="createdDate")
    def created_date(self) -> str:
        """
        The template whose creation time is less than or equal to the specified time. The format is: YYYY-MM-DDThh:mm::ssZ.
        """
        return pulumi.get(self, "created_date")

    @property
    @pulumi.getter
    def description(self) -> str:
        """
        Description of the OOS Template.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="hasTrigger")
    def has_trigger(self) -> bool:
        """
        Is it triggered successfully.
        """
        return pulumi.get(self, "has_trigger")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        ID of the OOS Template. The value is same as template_name.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="shareType")
    def share_type(self) -> str:
        """
        The sharing type of the template. Valid values: `Private`, `Public`.
        """
        return pulumi.get(self, "share_type")

    @property
    @pulumi.getter
    def tags(self) -> Mapping[str, Any]:
        """
        A mapping of tags to assign to the resource.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter(name="templateFormat")
    def template_format(self) -> str:
        """
        The format of the template. Valid values: `JSON`, `YAML`.
        """
        return pulumi.get(self, "template_format")

    @property
    @pulumi.getter(name="templateId")
    def template_id(self) -> str:
        """
        ID of the OOS Template resource.
        """
        return pulumi.get(self, "template_id")

    @property
    @pulumi.getter(name="templateName")
    def template_name(self) -> str:
        """
        Name of the OOS Template.
        """
        return pulumi.get(self, "template_name")

    @property
    @pulumi.getter(name="templateType")
    def template_type(self) -> str:
        """
        The type of OOS Template.
        """
        return pulumi.get(self, "template_type")

    @property
    @pulumi.getter(name="templateVersion")
    def template_version(self) -> str:
        """
        Version of the OOS Template.
        """
        return pulumi.get(self, "template_version")

    @property
    @pulumi.getter(name="updatedBy")
    def updated_by(self) -> str:
        """
        The user who updated the template.
        """
        return pulumi.get(self, "updated_by")

    @property
    @pulumi.getter(name="updatedDate")
    def updated_date(self) -> str:
        """
        The time when the template was updated.
        """
        return pulumi.get(self, "updated_date")


